#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;
uniform sampler2D Sampler1;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform float GameTime;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec2 texCoord1;
in vec4 normal;
in float isMarker;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;
    if (color.a < 0.1) {
        discard;
    }
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
    if (isMarker == 1.0){
        if (gl_FragCoord.xy == vec2(0.5,0.5)){
            fragColor = vec4(texture(Sampler0, texCoord0).rgb,1.0);
        }else discard;
    }else{
        vec4 texture = texture(Sampler0, texCoord0);
        if (texture.a * 255 == 253) fragColor = texture;
    }
    // fragColor = vec4(0,1,0,0.99);
}
