#version 150

#moj_import <light.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in vec2 UV1;
in ivec2 UV2;
in vec3 Normal;

uniform sampler2D Sampler2;
uniform sampler2D Sampler0;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;

uniform vec3 Light0_Direction;
uniform vec3 Light1_Direction;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;
out vec2 texCoord1;
out vec2 texCoord2;
out vec4 normal;
out float isMarker;

void main() {
    vec4 color = texture(Sampler0,UV0) * 255;
    bool vshmarker = false;
    if (color.a >= 254 && length(Position) < 1.5){
        isMarker = 1.0;
        vshmarker = true;
    }
    vec4 tmp = ProjMat * ModelViewMat * vec4(Position, 1.0);
    if (vshmarker){
        if ((mod(gl_VertexID, 4)) == 0){
            tmp = vec4(-1,-0.9,-1,1);
        }else if((mod(gl_VertexID, 4)) == 1){
            tmp = vec4(-1,-1,-1,1);
        }else if((mod(gl_VertexID, 4)) == 2){
            tmp = vec4(-0.9,-1,-1,1);
        }else if((mod(gl_VertexID, 4)) == 3){
            tmp = vec4(-0.9,-0.9,-1,1);
        }
    }else{
        tmp.z = ((tmp.z / tmp.w - 1.0) * 10 + 1.0) * tmp.w;
    }
    
    gl_Position = tmp;

    vertexDistance = length((ModelViewMat * vec4(Position, 1.0)).xyz);
    vertexColor = minecraft_mix_light(Light0_Direction, Light1_Direction, Normal, Color) * texelFetch(Sampler2, UV2 / 16, 0);
    texCoord0 = UV0;
    texCoord1 = UV1;
    texCoord2 = UV2;
    normal = ProjMat * ModelViewMat * vec4(Normal, 0.0);
}
